from turtle import *
from random import randint

"""
Ce fichier est expliqué ici : https://nsi.xyz/py2png
Un autre tutoriel permet de commencer : https://nsi.xyz/tutoriels/decouvrir-le-module-turtle-de-python/
"""

try:
    from PIL import Image
    pillow_installed = True
except:
    print("Oops! - ModuleNotFoundError: No module named 'PIL' - RTFM :")
    print("https://nsi.xyz/py2png")
    pillow_installed = False

# Uniquement des lettres, des chiffres, un tiret. Rien d'autre.
# https://learn.microsoft.com/fr-fr/windows/win32/fileio/naming-a-file
titre = "Spirale - construite avec turtle"

# Définir le titre de la fenêtre de turtle + propagande ^^
title(titre+" | Au lycée, la meilleure spécialité, c'est la spé NSI")

# definir la taille de la fenêtre en 720p (Largeur, Hauteur)
# La tortue part du centre, au point de coordonnées (0,0)
setup(1280, 720)

# La tortue va à la vitesse du lièvre et active sa cape d'invisibilité
speed(0)
hideturtle()

# ============== MON SCRIPT PYTHON ==============

penup()
colormode(255)
speed(0)

goto(-640,0)
pendown()
for i in range(720):
    color = (0,0, 255-round((i/(720/255))))
    pencolor(color)
    forward(1280)
    goto(-640,-360+i)


penup()
goto(0, 0)
pendown()


def plage():
    speed(3)
    penup()
    goto(-500, -500)
    color = (230, 230, 60)
    pensize(500)
    pencolor(color)
    pendown()
    forward(1000)
    
    
def bas_parasol():
    penup()
    goto(300,-250)
    color = (158, 158, 158)
    pensize(20)
    pencolor(color)
    pendown()
    left(90)
    forward(150)
    
def haut_parasol():
    penup()
    color = (255, 10, 137)
    pensize(1)
    pencolor(color)
    right(90)
    forward(75)
    fillcolor(color)
    pendown()
    begin_fill()
    for i in range(3):
        left(120)
        forward(150)
    end_fill()
    
    goto(225,-100)
    pencolor(255, 163, 211)
    ymontagne = -100
    for i in range(14):
        pendown()
        goto(300,ymontagne)
        goto(375,-100)
        penup()
        goto(225,-100)
        ymontagne += 10
    
def parasol():
    bas_parasol()
    haut_parasol()
    
def bas_parasol2():
    penup()
    goto(-150,-250)
    pensize(15)
    pencolor(158, 158, 158)
    pendown()
    left(90)
    forward(100)
    
def haut_parasol2():
    penup()
    pensize(1)
    pencolor(38, 150, 60)
    right(90)
    forward(50)
    fillcolor(38, 150, 60)
    pendown()
    begin_fill()
    for i in range(3):
        left(120)
        forward(100)
    end_fill()
    
    goto(-200,-150)
    pencolor(62, 237, 96)
    ymontagne = -150
    for i in range(13):
        pendown()
        goto(-150,ymontagne)
        goto(-100,-150)
        penup()
        goto(-200,-150)
        ymontagne += 7.5
    
    
    
def parasol2():
    bas_parasol2()
    haut_parasol2()
    
def etoile():
    for i in range(50):
        penup()
        goto(randint(-720,720), randint(0,360))
        pendown()
        pencolor(255, 255, 255)
        lcercle = randint(1,3)
        fillcolor('white')
        begin_fill()
        circle(lcercle)
        end_fill()
    
def lune():
    penup()
    goto(420, 170)
    pendown()
    pencolor(194, 194, 194)
    fillcolor(194, 194, 194)
    begin_fill()
    circle(60)
    end_fill()
    penup()
    goto(390, 220)
    pendown()
    pencolor(148, 148, 148)
    fillcolor(148, 148, 148)
    begin_fill()
    circle(20)
    end_fill()
    penup()
    goto(430, 250)
    pendown()
    begin_fill()
    circle(15)
    end_fill()


etoile()
plage()
parasol()
parasol2()
lune()







# ============== GENERER DES IMAGES AUTOMATIQUEMENT ==============

image = getcanvas()
nom_du_fichier_sans_extension=titre+"_"+hex(randint(2**30+2**25,2**30+2**25+2**24-1))[2:]

# Génère un fichier .ps
image.postscript(file=nom_du_fichier_sans_extension+".ps", colormode='color')

# Ouvre le fichier .ps et génère le fichier .png


try:
    psimage = Image.open(nom_du_fichier_sans_extension+".ps")
    psimage.load(scale=2)
    psimage_resized = psimage.resize((1280, 720))
    psimage.save(nom_du_fichier_sans_extension+".png")
    print(nom_du_fichier_sans_extension+".png", psimage.size, "sauvegardé dans le dossier")    
    
except:
    if not pillow_installed:
        print("Oops! - ModuleNotFoundError: No module named 'PIL' - RTFM :")
        print("https://nsi.xyz/py2png")
    else:
        print("Oops! - 'ghostscript' not installed- RTFM :")
        print("https://nsi.xyz/py2png")

exitonclick()